leetcode:三数之和---双指针

问题:

给你一个整数数组 nums ,判断是否存在三元组 [nums[i], nums[j], nums[k]] 满足 i != j、i != k 且 j != k ,同时还满足 nums[i] + nums[j] + nums[k] == 0 。请

你返回所有和为 0 且不重复的三元组。

**注意:**答案中不可以包含重复的三元组。

示例:

示例 1:

复制代码
输入:nums = [-1,0,1,2,-1,-4]
输出:[[-1,-1,2],[-1,0,1]]
解释:
nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。
nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。
nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。
不同的三元组是 [-1,0,1] 和 [-1,-1,2] 。
注意,输出的顺序和三元组的顺序并不重要。

示例 2:

复制代码
输入:nums = [0,1,1]
输出:[]
解释:唯一可能的三元组和不为 0 。

示例 3:

复制代码
输入:nums = [0,0,0]
输出:[[0,0,0]]
解释:唯一可能的三元组和为 0 。

提示:

3 <= nums.length <= 3000

-105 <= nums[i] <= 105

代码(思路在代码上注释了):

java 复制代码
 public List<List<Integer>> threeSum(int[] nums) {
        //排序,方便后续双指针移动
        Arrays.sort(nums);
        //返回值类型
        List<List<Integer>>lists=new ArrayList<>();
        //定义集合里面的集合,数组内容将会进入的集合
        List<Integer>list;
        //数组的长度
        int len=nums.length;
        //后续使用的三个指针,其中a为定。b,c为动,sum为三个数之和
        // a,b,c同时为数组索引
        int a,b,c,sum;
        //循环遍历
        for(int i=0;i<len-2;i++){
            //a,b,c赋初位置
            a=i;b=i+1;c=len-1;
            if(nums[a]>0){
                //如果nums[a]大于0那么再加两个大于0的数还是大于0
                continue;
            }
            if(a>0&&nums[a-1]==nums[a]){
                //当a走到下一个时避免与上一个相同
                continue;
            }
            while(b<c){
                //求和
                sum=nums[a]+nums[b]+nums[c];
                if(sum>0){
                    //大于0,则num[c]过大c--;
                    //同时避免相同
                    //此处建议这样写,c--单独写会超时
                    while(b<c&&nums[c]==nums[--c]);
                }else if(sum<0){
                    //小于0,则num[b]过小b++;
                    //同时避免相同
                    //此处建议这样写,b++单独写会超时
                    while(b<c&&nums[b]==nums[++b]);
                }else{
                    //sum=0时,加入内层集合
                    //注意每次创建新的内部集合(List<List<Integer>>此处是泛型)
                    //就当作内部和外部(不是准确这种说法)
                    list=new ArrayList<>();
                    list.add(nums[a]);
                    list.add(nums[b]);
                    list.add(nums[c]);
                    //将内部集合放入外层集合
                    //注意外层集合创建一次即可
                    lists.add(list);
                    //此处是为了避免出现相同的内部集合
                    while(b<c&&nums[b]==nums[++b]);
                    while(b<c&&nums[c]==nums[--c]);
                }
            }
        }
        //最终返回外层集合
        return lists;
    }

结果:

相似双指针题:

这道比较简单:

leetcode:最接近的三数之和---(双指针,排序,数组)-CSDN博客

由于这道题最终结果只有一个,所以作者我没有去重写while判断

相关推荐
写后端的胖头鱼7 小时前
一文详解B+树原理(附场景+示例)
数据结构·b树
怕浪猫8 小时前
RAG 面试 6 连问,从原理到优化全部覆盖
python·算法·面试
无线通信科研笔记9 小时前
IEEE TVT 2026 论文精读与完整复现|相位误差如何重塑近场 RIS 的幅相响应
论文阅读·人工智能·python·算法·论文笔记
daidaidaiyu9 小时前
ThingsBoard 集群的核心逻辑源码分析
java
mmmmath_39 小时前
二叉树の递归遍历
算法
All for pursuit.10 小时前
【位运算-1】338.比特位计数
数据结构·c++·算法·leetcode
我可能是个假开发10 小时前
FTP Unicode 文件名导致 `550` 的问题分析与解决方案
java·开发语言·spring
caoerzhong10 小时前
中小企业上 WMS 该先上哪几块:JeeWMS 开源 Java 仓库管理系统的分批上线清单
java·python·开源
小师兄吃牛肉10 小时前
C语言中的nullptr有必要吗
c语言·c++·算法
【JAVA】玩家11 小时前
Spring核心原理全解析:从零到生产实战
java·后端·spring